Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | Friends | List of all members
Quattro9Graph Class Reference

This class parses Quattro9Pro graph file. More...

`#include <Quattro9Graph.h>`

## Public Member Functions
| Quattro9Graph (Quattro9Parser &parser)
| constructor More...
| ~Quattro9Graph ()
| destructor More...
void | setListener (WKSContentListenerPtr &listen)
| sets the listener More...
void | cleanState ()
| clean internal state More...
void | updateState ()
| update the state (need to be called before sending data) More...
bool | getColor (int id, WPSColor &color) const
| returns the color corresponding to an id More...
bool | getPattern (int id, WPSGraphicStyle::Pattern &pattern) const
| returns the pattern corresponding to a pattern id between 0 and 24 More...

## Protected Member Functions
int | version () const
| return the file version More...
void | storeObjects (std::map< librevenge::RVNGString, WPSEmbeddedObject > const &nameToObjectMap)
| stores the OLE objets More...
bool | sendPageGraphics (int sheetId) const
| send the page graphic corresponding to a sheet More...
bool | sendShape (Quattro9GraphInternal::Graph const &graph, int sheetId) const
| send a shape More...
bool | sendShape (Quattro9GraphInternal::Shape const &shape, WPSTransformation const &transf) const
| send a shape (recursif) More...
bool | sendShape (WPSGraphicShape const &shape, WPSGraphicStyle const &style, WPSTransformation const &transf) const
| send a shape More...
bool | sendOLE (Quattro9GraphInternal::Graph const &graph, int sheetId) const
| send a OLE More...
bool | sendTextbox (Quattro9GraphInternal::Graph const &graph, int sheetId) const
| send a textbox More...
bool | readBeginEnd (std::shared_ptr< WPSStream > stream, int sheetId)
| read the begin/end graph zone: 1401/1402 More...
bool | readBeginEndZone (std::shared_ptr< WPSStream > const &stream)
| try to read a begin/end zone: 2051 More...
bool | readGraphHeader (std::shared_ptr< WPSStream > const &stream)
| try to read a graph header zone: 2051 More...
bool | readFrameStyle (std::shared_ptr< WPSStream > const &stream)
| try to read a frame style zone: 2131 More...
bool | readFramePattern (std::shared_ptr< WPSStream > const &stream)
| try to read a frame style zone: 2141 More...
bool | readFrameHeader (std::shared_ptr< WPSStream > const &stream)
| try to read a frame header zone: 2171 More...
bool | readOLEName (std::shared_ptr< WPSStream > const &stream)
| try to read the OLE name zone: 21d1 More...
bool | readShape (std::shared_ptr< WPSStream > const &stream)
| try to read a shape zone: 2221, 23d1 More...
bool | readShapeRec (std::shared_ptr< WPSStream > const &stream, long endPos, Quattro9GraphInternal::Shape &shape, WPSGraphicStyle const &actStyle)
| try to read a shape sub zone: 2221, 23d1 More...
bool | readTextboxStyle (std::shared_ptr< WPSStream > const &stream)
| try to read a textbox style zone: 2371 More...
bool | readTextboxText (std::shared_ptr< WPSStream > const &stream)
| try to read a textbox text zone: 2372 More...

## Private Member Functions
| Quattro9Graph (Quattro9Graph const &orig)=delete
Quattro9Graph & | operator= (Quattro9Graph const &orig)=delete

## Private Attributes
std::shared_ptr< WKSContentListener > | m_listener
Quattro9Parser & | m_mainParser
| the listener (if set) More...
std::shared_ptr< Quattro9GraphInternal::State > | m_state
| the internal state More...

## Friends
class | Quattro9Parser
class | Quattro9GraphInternal::SubDocument

## Detailed Description

This class parses Quattro9Pro graph file.

## Constructor & Destructor Documentation

## ◆ Quattro9Graph() [1/2]

Quattro9Graph::Quattro9Graph | ( | Quattro9Parser & | parser | ) |
| explicit

constructor

## ◆ ~Quattro9Graph()

Quattro9Graph::~Quattro9Graph | ( |  | ) |

destructor

## ◆ Quattro9Graph() [2/2]

Quattro9Graph::Quattro9Graph | ( | Quattro9Graph const & | orig | ) |
| private delete

## Member Function Documentation

## ◆ cleanState()

void Quattro9Graph::cleanState | ( |  | ) |

clean internal state

## ◆ getColor()

bool Quattro9Graph::getColor | ( | int | id,
|  | WPSColor & | color
| ) |  | const

returns the color corresponding to an id

## ◆ getPattern()

bool Quattro9Graph::getPattern | ( | int | id,
|  | WPSGraphicStyle::Pattern & | pattern
| ) |  | const

returns the pattern corresponding to a pattern id between 0 and 24

## ◆ operator=()

Quattro9Graph& Quattro9Graph::operator= | ( | Quattro9Graph const & | orig | ) |
| private delete

## ◆ readBeginEnd()

bool Quattro9Graph::readBeginEnd | ( | std::shared_ptr< WPSStream > | stream,
|  | int | sheetId
| ) |  |
| protected

read the begin/end graph zone: 1401/1402

## ◆ readBeginEndZone()

bool Quattro9Graph::readBeginEndZone | ( | std::shared_ptr< WPSStream > const & | stream | ) |
| protected

try to read a begin/end zone: 2051

## ◆ readFrameHeader()

bool Quattro9Graph::readFrameHeader | ( | std::shared_ptr< WPSStream > const & | stream | ) |
| protected

try to read a frame header zone: 2171

## ◆ readFramePattern()

bool Quattro9Graph::readFramePattern | ( | std::shared_ptr< WPSStream > const & | stream | ) |
| protected

try to read a frame style zone: 2141

## ◆ readFrameStyle()

bool Quattro9Graph::readFrameStyle | ( | std::shared_ptr< WPSStream > const & | stream | ) |
| protected

try to read a frame style zone: 2131

## ◆ readGraphHeader()

bool Quattro9Graph::readGraphHeader | ( | std::shared_ptr< WPSStream > const & | stream | ) |
| protected

try to read a graph header zone: 2051

## ◆ readOLEName()

bool Quattro9Graph::readOLEName | ( | std::shared_ptr< WPSStream > const & | stream | ) |
| protected

try to read the OLE name zone: 21d1

## ◆ readShape()

bool Quattro9Graph::readShape | ( | std::shared_ptr< WPSStream > const & | stream | ) |
| protected

try to read a shape zone: 2221, 23d1

## ◆ readShapeRec()

bool Quattro9Graph::readShapeRec | ( | std::shared_ptr< WPSStream > const & | stream,
|  | long | endPos,
|  | Quattro9GraphInternal::Shape & | shape,
|  | WPSGraphicStyle const & | actStyle
| ) |  |
| protected

try to read a shape sub zone: 2221, 23d1

Referenced by readShape().

## ◆ readTextboxStyle()

bool Quattro9Graph::readTextboxStyle | ( | std::shared_ptr< WPSStream > const & | stream | ) |
| protected

try to read a textbox style zone: 2371

## ◆ readTextboxText()

bool Quattro9Graph::readTextboxText | ( | std::shared_ptr< WPSStream > const & | stream | ) |
| protected

try to read a textbox text zone: 2372

## ◆ sendOLE()

bool Quattro9Graph::sendOLE | ( | Quattro9GraphInternal::Graph const & | graph,
|  | int | sheetId
| ) |  | const
| protected

send a OLE

Referenced by sendPageGraphics().

## ◆ sendPageGraphics()

bool Quattro9Graph::sendPageGraphics | ( | int | sheetId | ) | const
| protected

send the page graphic corresponding to a sheet

## ◆ sendShape() [1/3]

bool Quattro9Graph::sendShape | ( | Quattro9GraphInternal::Graph const & | graph,
|  | int | sheetId
| ) |  | const
| protected

send a shape

Referenced by sendPageGraphics(), and sendShape().

## ◆ sendShape() [2/3]

bool Quattro9Graph::sendShape | ( | Quattro9GraphInternal::Shape const & | shape,
|  | WPSTransformation const & | transf
| ) |  | const
| protected

send a shape (recursif)

## ◆ sendShape() [3/3]

bool Quattro9Graph::sendShape | ( | WPSGraphicShape const & | shape,
|  | WPSGraphicStyle const & | style,
|  | WPSTransformation const & | transf
| ) |  | const
| protected

send a shape

## ◆ sendTextbox()

bool Quattro9Graph::sendTextbox | ( | Quattro9GraphInternal::Graph const & | graph,
|  | int | sheetId
| ) |  | const
| protected

send a textbox

Referenced by sendPageGraphics().

## ◆ setListener()

void Quattro9Graph::setListener | ( | WKSContentListenerPtr & | listen | ) |
| inline

sets the listener

## ◆ storeObjects()

void Quattro9Graph::storeObjects | ( | std::map< librevenge::RVNGString, WPSEmbeddedObject > const & | nameToObjectMap | ) |
| protected

stores the OLE objets

## ◆ updateState()

void Quattro9Graph::updateState | ( |  | ) |

update the state (need to be called before sending data)

## ◆ version()

int Quattro9Graph::version | ( |  | ) | const
| protected

return the file version

## Friends And Related Function Documentation

## ◆ Quattro9GraphInternal::SubDocument

friend class Quattro9GraphInternal::SubDocument
| friend

## ◆ Quattro9Parser

friend class Quattro9Parser
| friend

## Member Data Documentation

## ◆ m_listener

std::shared_ptr<WKSContentListener> Quattro9Graph::m_listener
| private

Referenced by sendOLE(), sendShape(), sendTextbox(), and setListener().

## ◆ m_mainParser

Quattro9Parser& Quattro9Graph::m_mainParser
| private

the listener (if set)

the main parser

Referenced by readOLEName(), readTextboxStyle(), readTextboxText(), sendOLE(), sendShape(), sendTextbox(), and version().

## ◆ m_state

std::shared_ptr<Quattro9GraphInternal::State> Quattro9Graph::m_state
| private

the internal state

Referenced by cleanState(), getColor(), getPattern(), readBeginEnd(), readBeginEndZone(), readGraphHeader(), readOLEName(), readShape(), readShapeRec(), readTextboxStyle(), readTextboxText(), sendOLE(), sendPageGraphics(), storeObjects(), and version().

The documentation for this class was generated from the following files:

- Quattro9Graph.h
- Quattro9Graph.cpp